title High quality 2--pass video encoding script v3.5
@echo off
cls
echo        -----------------------------------------------------------------
echo        High quality two-pass video encoding script for the mobile phones
echo        which support MPEG4 video playback and AAC or AMR audio playback.
echo        Script Version - 3.5  --  (c) Archy, mod by ApxuBatop, MotoFan.ru
echo        Thanks a million to blackbox, Pauk, Andy51, Inferpse and bigcrush
echo        -----------------------------------------------------------------
echo.
;rem
;rem    Russian support topic here:
;rem    http://forum.motofan.ru/index.php?showtopic=55521
;rem    English support topic here:
;rem    http://motomodders.net/Default.aspx?tabid=55&forumid=41&view=topic&postid=334372
;rem
;rem
;rem ============================== SETTINGS ===============================
;rem
;rem    Put your source video files to the AVI directory.
;rem    They could be *.avi, *.mpg, *.mpeg, *.vob, *.wmv or *.asf.
;rem    After that run script and take *.mp4 files in AVI directory.
;rem    
;rem    Need more format support? If VurtualDub can open them, inform me (ApxuBatop).
;rem
;rem                      /  DDDDDD   VV    VV  DDDDDD  \
;rem    _________________/   DD   DD   VV  VV   DD   DD  \_________________
;rem                     \   DD   DD    VVVV    DD   DD  /
;rem                      \  DDDDDD      VV     DDDDDD  /  < READY >
;rem
;rem    If you encode DVD and it consists of many parts (VTS_XX_X.VOB),
;rem    put all this files to the AVI directory, they would processed separately,
;rem    and then would be merged to VTS_XX.MP4. (instead of VTS_XX could
;rem    be anything, the point is that the last digit should indicate
;rem    sequence). Usually VTS_XX_0.VOB contains adverts or baners,
;rem    that's why it is processed separately.
;rem    
;rem    VISTA USERS!  I don't know why, but in Vista it is required to
;rem    upload whole vob mpeg-2 file to the memory, that's why if you
;rem    have less than 1,5 GB RAM (256, 512, 1024) don't do anything. =)
;rem
set DVD_aspect_W=16
set DVD_aspect_H=9
;rem                 DVD aspect ratio. Usually DVD has unproportional aspect ratio,
;rem                 that's why video could become overextended or enlarged.
;rem                 Often DVD has 16/9 aspect:
;rem                   set DVD_aspect_W=16
;rem                   set DVD_aspect_H=9
;rem                 But it is better to check it by yourself. If somebody could
;rem                 make programm, that would return aspect values - inform me
;rem                 (ApxuBatop).
set StartMS=0
set EndMS=1
;rem                Sets a particular range value.  If StartMS=0, the start offset
;rem                is used, and if EndMS=1, the end offset is used.  The start offset is
;rem                measured in milliseconds from the beginning, and the end offset is
;rem                in milliseconds from the end. O_o
;rem
;rem                If StartMS=0 and EndMS=1 - video will be processed COMPLETELY.
;rem
set CropTop=0
set CropBottom=0
set CropLeft=0
set CropRight=0
;rem                 Cropping. If you need to delete black areas from the video...
;rem
set ResolutionX=176
;rem                 Video width. Autocorrects, if it's need.
;rem
set ResolutionY=0
;rem
;rem                 Video height. Set 0, if you want autoheight. Autocorrects, if it's need.
;rem
set ResolutionY_proper=0
;rem
;rem                 Necessary target video resolution. Adds black areas at top and bottom.
;rem                 Useful for L7e, where in fullscreen video playback video stretches
;rem                 and loses it aspect ratio. To encode widescreen video for L7e set
;rem                    set ResolutionX=220
;rem                    set ResolutionY_proper=176
;rem                 If you don't want to add any black stripes, set 0.
;rem                 Autocorrects, if it's need.
;rem
set BitrateAudio=40
;rem                 Audio Bitrate. The more you set, better quality and lesser speed
;rem                 you'll have. If you want to encode stereo, double the bitrate,
;rem                 because 2 channels require two times more data.
;rem                 If you don't want audio stream, set 0.
;rem                 Set 5-12, if you want AMR instead of AAC (for old phones).
;rem
set AudioChannels=1
;rem                 Amount of channels. 1 - mono, 2 - stereo.
;rem
set Normalize=1
;rem                 Normalizes audio. Sets recommended volume. (1-yes/0-no)
;rem                 
set VideoFPS=1/2
;rem                 Video FPS (Frames Per Ssecond). If you need 15 fps, set 150,
;rem                 if 10 - set 100, 12,5 - 125, etc.
;rem                 If you set 1/X, where X - 1,2,3,...,9, it means, that
;rem                 FPS would be 1,2,3,...,9 times less, than it is in the source video.
;rem                 (1/1 - no changes). I recommend to set 1/2.
;rem
set AVsync=1
;rem                 If AVsync=1, video fps corrects to audio lenght. May cause
;rem                 video/audio synchronization or desynchronization. Change,
;rem                 if you have problems. With vob and wmv turns it off. (1-yes/0-no)
;rem
set VideoSplit=300
;rem                 Video Split settings. May help with gabs and slow playback of 
;rem                 long video files. Also allows simple video rewind.
;rem                 Value means split time in seconds. 300 is optimal for E1.
;rem                 Set 0, if you don't want video split.
;rem
set DeleteMP4=1
;rem                 Delete or Not non splited file. Works only if VideoSplit
;rem                 is on. (1-yes/0-no)
;rem
set SplitToSubdir=1
;rem                 Splited files would be moved to the sub directory. (1-yes/0-no)
;rem
set BitrateVideo=100
;rem                 
;rem                 Video Bitrate. 100 is optimal for E1.
;rem
set XviD_Profile=simpleL2
;rem
;rem                 XviD Profile. Available 3 values:
;rem                   simpleL2 - supports bitrate from 10 to 128
;rem                   simpleL3 - supports bitrate from 10 to 384
;rem                   advanced_simpleL3 - supports bitrate from 10 to 768
;rem                 simpleL2 is optimal for E1. 0 - autoselect (not recommended).
;rem
set Contrast=6
set Brightness=10
;rem                 Brightness and contrast. Sets in per cent.
;rem                 -100 - min, 0 - original, 100 - max.
;rem                 For E1 optimal is Contrast=6 Brightness=10
set Sharpen=30
;rem                 Sharpen. Recommended - 30. 0 - no sharpen. (0-127)
;rem
set Subtitles=50
;rem                 Subtitles overlay. Put subtitles files with video files.
;rem                 Subtitles name and videofile name must be the same.
;rem                 Value means size. Default 50, min - 1, max - 100.
;rem                 If there is no supported subs, they wouldn't be added.
;rem                 If you don't want subtitles, set 0.
;rem
set SwitchOFF=N
;rem                 What to do after encoding?
;rem                 ,-----------------------------.
;rem                 | Value       | Action        |
;rem                 |-------------+---------------|
;rem                 | shutdown    | Shutdown      |
;rem                 | standby     | Standby       |
;rem                 | logoff      | Log off       |
;rem                 | hibernate   | Hibernate     |
;rem                 | hangup      | Hang up (???) |
;rem                 | restart     | Restart       |
;rem                 | N           | Do nothing    |
;rem                 -----------------------------
;rem                 
;rem                 
set Priority=BELOWNORMAL
;rem                 Script Priority. Avaible LOW, BELOWNORMAL, NORMAL,
;rem                 ABOVENORMAL, HIGH, REALTIME. Default BELOWNORMAL.
;rem                 On values above NORMAL system may become unstable.
set Minimize=/MIN
;rem                 Background work of the script.
;rem                 Avaible values:
;rem		        /MIN - minimize all opening windows.
;rem                    <nothing> - windows would be opened as normal.
set Del_AVI=N
;rem                 Delete or Not source video file. (Y-yes/N-no)
set Del_WAV=Y
set Del_M4A=Y
set Del_AV4=Y
set Del_STATS=Y
;rem                 Delete or Not temporary files.
set SkipAudio_WAV=N
set SkipAudio_M4A=N
set SkipStats=N
set SkipVideo=N
set SkipMux=N
;rem                 You can skip each step of the procedure. :)
set AddFilters=N
;rem                 This is option for advanced users. If you need to add your
;rem                 filters, write them into the file !filters.
;rem                 VirtualDub docs - http://virtualdub.org/docs/vdscript.txt
;rem                 instance[x] - X should start from 2. If you want to save your
;rem                 filter settings, use File->Save processing settings, 
;rem                 and then copy necessary strings into !filters.
;rem 
;rem   Based on ffdshow build by xxl, VirtualDub MPEG2, XviD, MP4Box...
;rem   ffdshow:          http://sourceforge.net/project/showfiles.php?group_id=173941
;rem   Xvid:             http://www.koepi.org/XviD-1.1.2-01112006.exe
;rem   VirtualDub MPEG2: http://fcchandler.home.comcast.net/stable/VirtualDub-MPEG2.zip
;rem   MP4Box:           http://gpac.sourceforge.net/doc_mp4box.php
;rem   

;rem  Incorrect translation? Inform me (ApxuBatop).

;REM  =======================================================================
;REM |                            END OF SETTINGS                           |
;REM  =======================================================================

set Del_vcf=Y


if %1A==AA goto AVI
if %1R==AVIR goto RENM
if %1R==MPGR goto RENM_MPG
if %1R==MPEGR goto RENM_MPEG
if %1R==VOBR goto RENM_VOB
if %1R==ASFR goto RENM_ASF
if %1R==WMVR goto RENM_WMV

if NOT exist AVI md AVI

renamer.exe

if exist .\AVI\*. del .\AVI\*. 
echo Searching for *.avi files...
for %%f in (.\AVI\*.avi) do call %0 AVI %%f
echo Searching for *.mpg files...
for %%f in (.\AVI\*.mpg) do call %0 MPG %%f
echo Searching for *.mpeg files...
for %%f in (.\AVI\*.mpeg) do call %0 MPEG %%f
echo Searching for *.vob files...
for %%f in (.\AVI\*.vob) do call %0 VOB %%f
echo Searching for *.asf files...
for %%f in (.\AVI\*.asf) do call %0 ASF %%f
echo Searching for *.wmv files...
for %%f in (.\AVI\*.wmv) do call %0 WMV %%f
if exist swoff.exe if NOT %SwitchOFF%==N start swoff.exe /wait:20 /%SwitchOFF%
goto FIN

:AVI
set EXT=%3
if A%3==AMPG (ren %2 *.mpg) else (
 if A%3==AMPEG (ren %2 *.mpeg) else (
  if A%3==AVOB (ren %2 *.vob) else (
   if A%3==AASF (ren %2 *.asf) else (
    if A%3==AWMV (ren %2 *.wmv) else (
     ren %2 *.avi
     set EXT=avi
    )
   )
  )
 )
)

if errorlevel 1 (
	echo   २ 䠩 - ஡  䠩 %2.  %2.%EXT%
	goto FIN
)

set Process_counter=1
set Process_all=0

if %BitrateAudio%==0 set SkipAudio_WAV=Y
if %BitrateAudio%==0 set SkipAudio_M4A=Y
if %BitrateAudio%==0 set DisAudio=

if %SkipAudio_WAV%==N ( set /a Process_all=%Process_all%+1
 ) else ( if %SkipVideo%==N ( set /a Process_all=%Process_all%+1
  ) else ( if %SkipStats%==N ( set /a Process_all=%Process_all%+1
)))

if %SkipMux%==N set /a Process_all=%Process_all%+1
if NOT %VideoSplit%==0 set /a Process_all=%Process_all%+1
if %SkipAudio_M4A%==N if %Normalize%==1 set /a Process_all=%Process_all%+1
if %SkipAudio_M4A%==N set /a Process_all=%Process_all%+1

title Step %Process_counter%/%Process_all% - %2.%EXT%

;rem Audio Settings Calculator

if %BitrateAudio%==0 GOTO NOAUDIO
if /i %BitrateAudio% LSS 13 (
set AudioChannels=1
set AudioFrequency=8000
if /i %BitrateAudio% LSS 5 set BitrateAudio=5
if %BitrateAudio%==5 set AMRbitrate=MR475
if %BitrateAudio%==6 set AMRbitrate=MR59
if %BitrateAudio%==7 set AMRbitrate=MR74
if %BitrateAudio%==8 set AMRbitrate=MR795
if %BitrateAudio%==9 set AMRbitrate=MR102
if %BitrateAudio%==10 set AMRbitrate=MR102
if %BitrateAudio%==11 set AMRbitrate=MR122
if %BitrateAudio%==12 set AMRbitrate=MR122
GOTO NOAUDIO
)
if %AudioChannels%==1 if /i %BitrateAudio% LSS 21 set BitrateAudio=24
if %AudioChannels%==2 if /i %BitrateAudio% LSS 42 set BitrateAudio=48
if %AudioChannels%==1 ( if /i %BitrateAudio% GTR 20 ( set AudioFrequency=16000
set AudioBandWidth=8000
)
if /i %BitrateAudio% GTR 29 ( set AudioFrequency=22050
set AudioBandWidth=11000
)
if /i %BitrateAudio% GTR 39 ( set AudioFrequency=24000
set AudioBandWidth=12000
)
if /i %BitrateAudio% GTR 49 ( set AudioFrequency=32000
set AudioBandWidth=16000
)
if /i %BitrateAudio% GTR 59 ( set AudioFrequency=44100
set AudioBandWidth=17000
)
if /i %BitrateAudio% GTR 79 ( set AudioFrequency=44100
set AudioBandWidth=18000
)
if /i %BitrateAudio% GTR 99 ( set AudioFrequency=44100
set AudioBandWidth=19000
))
if %AudioChannels%==2 ( if /i %BitrateAudio% GTR 40 ( set AudioFrequency=16000
set AudioBandWidth=8000
)
if /i %BitrateAudio% GTR 59 ( set AudioFrequency=22050
set AudioBandWidth=11000
)
if /i %BitrateAudio% GTR 79 ( set AudioFrequency=24000
set AudioBandWidth=12000
)
if /i %BitrateAudio% GTR 99 ( set AudioFrequency=32000
set AudioBandWidth=16000
)
if /i %BitrateAudio% GTR 119 ( set AudioFrequency=44100
set AudioBandWidth=17000
)
if /i %BitrateAudio% GTR 159 ( set AudioFrequency=44100
set AudioBandWidth=18000
)
if /i %BitrateAudio% GTR 199 ( set AudioFrequency=44100
set AudioBandWidth=19000
))

:NOAUDIO

;rem AVsync
if /i %EXT%==wmv set AVsync=0
if %AVsync%==1 set AVsync=-1

;rem dvd_detector

set dvd=0

if /i NOT %EXT%==vob goto NOT_VOB

set name=%2
set number=%name:~-1%
if /i %number% GEQ 1 if /i %number% LEQ 9 set /a number=%number%+1
if /i %number% GEQ 2 if /i %number% LEQ 10 ( set dvd=1
 set /a temp=%number%-2
)
if /i %number% GEQ 2 ( if /i %number% LEQ 10 ( set dvd=1
  if exist %name:~0,-1%%temp%.%ext% if %temp%==0 set dvd=0
  if exist %name:~0,-1%%number%.%ext% set dvd=1
 ) else (
  set dvd=0
)) else (
 set dvd=0
)
if %dvd%==1 if exist %name:~0,-1%%number%.%ext% set dvd=2
set /a temp=%name:~-1%-1
if %dvd%==1 if NOT exist %name:~0,-1%%temp%.%ext% set dvd=0
if NOT %dvd%==0 set AVsync=0
if %dvd%==2 set /a Process_all=%Process_all%-1

;rem dvd=0 - no sequence. dvd=1 exist number and nubmer-1 (last file). dvd=2 exist number and number+1


:NOT_VOB

;rem Resolution Calculator

if /i %EXT%==vob set /A ResolutionY=%ResolutionX%*%DVD_aspect_H%/%DVD_aspect_W%
set /a Video_Aspect=256*%DVD_aspect_W%/%DVD_aspect_H%-1

set ResolutionY_proper2=%ResolutionY_proper%

set /A ResolutionX=%ResolutionX%/2*2
if NOT %ResolutionY%==0 set /A ResolutionY=%ResolutionY%/2*2
set /A ResolutionY_proper=%ResolutionY_proper%/2*2

if NOT %ResolutionY_proper%==0 ( if /i %ResolutionY_proper% LSS %ResolutionY% set ResolutionY=%ResolutionY_proper%
) else (
set ResolutionY_proper=%ResolutionY%
)

;rem Profile Calculator

if %XviD_Profile%==0 ( if /i %BitrateVideo% LSS 101 set XviD_Profile=simpleL2
if /i %BitrateVideo% GTR 101 set XviD_Profile=simpleL3
if /i %BitrateVideo% GTR 257 set XviD_Profile=advanced_simpleL3
)

;rem Subs-detector


if NOT %Subtitles%==0 ( if exist %2.sub ( set SubtitlesEXT=sub
 ) else ( if exist %2.srt ( set SubtitlesEXT=srt
  ) else ( if exist %2.rt ( set SubtitlesEXT=rt
   ) else ( if exist %2.utf ( set SubtitlesEXT=utf
    ) else ( if exist %2.idx ( set SubtitlesEXT=idx
     ) else ( if exist %2.smi ( set SubtitlesEXT=smi
      ) else ( if exist %2.ssa ( set SubtitlesEXT=ssa
       ) else ( if exist %2.aqt ( set SubtitlesEXT=aqt
        ) else ( if exist %2.mpl ( set SubtitlesEXT=mpl
         ) else ( if exist %2.usf ( set SubtitlesEXT=usf
          ) else ( if exist %2.txt ( set SubtitlesEXT=txt
           ) else ( set Subtitles=0
))))))))))))

;rem brightness/contrast

if /i %Brightness% LSS -100 set Brightness=-100
if /i %Contrast% GTR 100 set Contrast=100
if /i %Brightness% LSS -100 set Brightness=-100
if /i %Contrast% GTR 100 set Contrast=100
set /a Brightness=%Brightness%*256/100
set /a Contrast=(%Contrast%*16/100)+16

if %dvd%==0 echo ************ Encoding %2.%EXT% ************
if %dvd%==1 echo ************ Encoding %2.%EXT% (DVD - last file) ************
if %dvd%==2 echo ************ Encoding %2.%EXT% (DVD - intermediate file) ************
echo.
echo  - XviD Profile: %XviD_Profile%
if NOT %BitrateAudio%==0 echo  - Audio Bitrate: %BitrateAudio% kb/s
echo  - Video Bitrate: %BitrateVideo% kb/s 
if NOT %VideoFPS:~1,1%==/ echo  - Video FPS: %VideoFPS:~0,-1%.%VideoFPS:~2,1% fps
if NOT %VideoFPS%==1/1 if %VideoFPS:~1,1%==/ echo  - Video FPS: %VideoFPS% from original
if %VideoFPS%==1/1 echo  - Video FPS: original
if NOT %VideoSplit%==0 echo  - Video split: %VideoSplit% sec.
echo.

cd ..


if exist .\VirtualDub\current.vcf del .\VirtualDub\current.vcf
if exist .\VirtualDub\temp del .\VirtualDub\temp

;rem FFDSHOW

if NOT exist user_ffdshow_audio.reg regedit /e user_ffdshow_audio.reg HKEY_CURRENT_USER\Software\GNU\ffdshow_audio
if NOT exist user_ffdshow_vfw.reg regedit /e user_ffdshow_vfw.reg HKEY_CURRENT_USER\Software\GNU\ffdshow_vfw
if NOT exist user_ffvdub.reg regedit /e user_ffvdub.reg HKEY_CURRENT_USER\Software\GNU\ffdshow\ffvdub
regedit /s VFW.reg
regedit /s ffvdub.reg
echo Windows Registry Editor Version 5.00 >ffvdub_settings.reg
echo.>>ffvdub_settings.reg
echo [HKEY_CURRENT_USER\Software\GNU\ffdshow\ffvdub] >>ffvdub_settings.reg

if NOT %Subtitles%==0 set t=%0
if NOT %Subtitles%==0 multitool.exe %t% >t
if NOT %Subtitles%==0 set /p t=<t
if NOT %Subtitles%==0 echo "subFlnm"="%t:~0,-9%AVI\\%2.%SubtitlesEXT%" >>ffvdub_settings.reg
if NOT %Subtitles%==0 multitool.exe %Subtitles% >t
if NOT %Subtitles%==0 set /p t=<t
if NOT %Subtitles%==0 echo "fontSizeA"=dword:%t% >>ffvdub_settings.reg
if %Subtitles%==0 echo "isSubtitles"=dword:00000000 >>ffvdub_settings.reg
multitool.exe %ResolutionX% >t
set /p t=<t
echo "resizeDx"=dword:%t% >>ffvdub_settings.reg
multitool.exe %ResolutionY% >t
set /p t=<t
echo "resizeDy"=dword:%t% >>ffvdub_settings.reg

if %ResolutionY%==0 echo "resizeIsDy0"=dword:00000001 >>ffvdub_settings.reg
if NOT %ResolutionY%==0 echo "resizeIsDy0"=dword:00000000 >>ffvdub_settings.reg
if %ResolutionY%==0 echo "resizeAscpect"=dword:00000001 >>ffvdub_settings.reg
if NOT %ResolutionY%==0 echo "resizeAscpect"=dword:00000000 >>ffvdub_settings.reg

if NOT %ResolutionY_proper2%==0 echo "resizeIsDy0"=dword:00000000 >>ffvdub_settings.reg
if NOT %ResolutionY_proper2%==0 multitool.exe %ResolutionY_proper2% >t
if NOT %ResolutionY_proper2%==0 set /p t=<t
if NOT %ResolutionY_proper2%==0 echo "resizeDy"=dword:%t% >>ffvdub_settings.reg
if NOT %ResolutionY_proper2%==0 if NOT %ResolutionY%==0 set /a Video_Aspect=256*%ResolutionX%/%ResolutionY%
if NOT %ResolutionY_proper2%==0 if NOT %ResolutionY%==0 echo "resizeAscpect"=dword:00000002 >>ffvdub_settings.reg
if NOT %ResolutionY_proper2%==0 multitool.exe %Video_Aspect% >t
if NOT %ResolutionY_proper2%==0 set /p t=<t
if NOT %ResolutionY_proper2%==0 if NOT %ResolutionY%==0 echo "aspectRatio"=dword:%t%00 >>ffvdub_settings.reg

multitool.exe %CropLeft% >t
set /p t=<t
echo "cropLeft"=dword:%t% >>ffvdub_settings.reg
multitool.exe %CropRight% >t
set /p t=<t
echo "cropRight"=dword:%t% >>ffvdub_settings.reg
multitool.exe %CropTop% >t
set /p t=<t
echo "cropTop"=dword:%t% >>ffvdub_settings.reg
multitool.exe %CropBottom% >t
set /p t=<t
echo "cropBottom"=dword:%t% >>ffvdub_settings.reg
multitool.exe %Sharpen% >t
set /p t=<t
echo "unsharp_strength"=dword:%t% >>ffvdub_settings.reg
del t
regedit /s ffvdub_settings.reg

;rem VIRTUAL_DUB

if %SkipStats%==Y if %SkipVideo%==Y if %SkipAudio_WAV%==Y goto MUX
if %SkipStats%==Y if %SkipVideo%==Y if %SkipAudio_WAV%==N echo Step %Process_counter%/%Process_all% - Extracting audio
if %SkipStats%==Y if %SkipVideo%==N if %SkipAudio_WAV%==Y echo Step %Process_counter%/%Process_all% - Encoding video using statistics file
if %SkipStats%==Y if %SkipVideo%==N if %SkipAudio_WAV%==N echo Step %Process_counter%/%Process_all% - Extracting audio and encoding video
if %SkipStats%==N if %SkipVideo%==Y if %SkipAudio_WAV%==Y echo Step %Process_counter%/%Process_all% - Collecting statistics
if %SkipStats%==N if %SkipVideo%==Y if %SkipAudio_WAV%==N echo Step %Process_counter%/%Process_all% - Extracting audio and collecting statistics
if %SkipStats%==N if %SkipVideo%==N if %SkipAudio_WAV%==Y echo Step %Process_counter%/%Process_all% - Collecting statistics and encoding video
if %SkipStats%==N if %SkipVideo%==N if %SkipAudio_WAV%==N echo Step %Process_counter%/%Process_all% - Extracting audio, collecting statistics and encoding video
set /a Process_counter=%Process_counter%+1

echo // VirtualDub job list (Sylia script format) >.\VirtualDub\current.vcf
echo //    .    ! >>.\VirtualDub\current.vcf
echo // >>.\VirtualDub\current.vcf
echo // $numjobs 1 >>.\VirtualDub\current.vcf
echo // >>.\VirtualDub\current.vcf
echo.>>.\VirtualDub\current.vcf
echo // $input "..\AVI\%2.%EXT%" >>.\VirtualDub\current.vcf
echo // $output "..\AVI\%2_av4.tmp" >>.\VirtualDub\current.vcf
echo // $state 0 >>.\VirtualDub\current.vcf
echo // $start_time 0 0 >>.\VirtualDub\current.vcf
echo // $end_time 0 0 >>.\VirtualDub\current.vcf
echo // $script >>.\VirtualDub\current.vcf
echo.>>.\VirtualDub\current.vcf
echo VirtualDub.Open("..\\AVI\\%2.%EXT%",0,0); >>.\VirtualDub\current.vcf
if %AVsync%==-1 echo VirtualDub.audio.SetSource(1);>>.\VirtualDub\current.vcf
if %AVsync%==0 echo VirtualDub.audio.SetSource(0);>>.\VirtualDub\current.vcf
echo VirtualDub.audio.SetMode(0);>>.\VirtualDub\current.vcf
echo VirtualDub.audio.SetInterleave(1,500,1,0,0);>>.\VirtualDub\current.vcf
echo VirtualDub.audio.SetClipMode(1,1);>>.\VirtualDub\current.vcf
echo VirtualDub.audio.SetConversion(0,0,0,0,0);>>.\VirtualDub\current.vcf
echo VirtualDub.audio.SetVolume();>>.\VirtualDub\current.vcf
echo VirtualDub.audio.SetCompression();>>.\VirtualDub\current.vcf
echo VirtualDub.audio.EnableFilterGraph(0);>>.\VirtualDub\current.vcf
echo VirtualDub.audio.filters.Clear();>>.\VirtualDub\current.vcf
echo VirtualDub.video.SetDepth(24,24);>>.\VirtualDub\current.vcf
echo VirtualDub.video.SetMode(3);>>.\VirtualDub\current.vcf
if NOT %VideoFPS:~1,1%==/ echo VirtualDub.video.SetFrameRate(%AVsync%,1);>>.\VirtualDub\current.vcf
if %VideoFPS:~1,1%==/ echo VirtualDub.video.SetFrameRate(%AVsync%,%VideoFPS:~2,1%);>>.\VirtualDub\current.vcf
echo VirtualDub.video.SetIVTC(0,0,-1,0);>>.\VirtualDub\current.vcf
echo VirtualDub.video.SetRange(0,0);>>.\VirtualDub\current.vcf
if NOT %VideoFPS:~1,1%==/ echo VirtualDub.video.SetTargetFrameRate(%VideoFPS%000,10000);>>.\VirtualDub\current.vcf
echo VirtualDub.video.SetCompression(0x64697678,0,10000,0);>>.\VirtualDub\current.vcf
if %SkipStats%==N copy /B .\VirtualDub\current.vcf + .\VirtualDub\pass1 .\VirtualDub\current.vcf >NUL
if %SkipStats%==N b64.exe b64 %BitrateVideo%>>.\VirtualDub\current.vcf
if %SkipStats%==N copy /B .\VirtualDub\current.vcf + .\VirtualDub\%XviD_Profile% .\VirtualDub\current.vcf >NUL
echo VirtualDub.video.filters.Clear();>>.\VirtualDub\current.vcf
echo VirtualDub.video.filters.Add("ffvdub");>>.\VirtualDub\current.vcf
echo VirtualDub.video.filters.Add("brightness/contrast");>>.\VirtualDub\current.vcf
echo VirtualDub.video.filters.instance[1].Config(%Brightness%,%Contrast%);>>.\VirtualDub\current.vcf
if %AddFilters%==Y copy /B .\VirtualDub\current.vcf + !filters .\VirtualDub\current.vcf >NUL
echo VirtualDub.subset.Delete();>>.\VirtualDub\current.vcf
if NOT %StartMS%%EndMS%==01 echo VirtualDub.video.SetRange(%StartMS%,%EndMS%); >>.\VirtualDub\current.vcf
if %SkipStats%==N echo VirtualDub.SaveAVI("..\\AVI\\%2_av4.tmp");>>.\VirtualDub\current.vcf
if %SkipVideo%==N copy /B .\VirtualDub\current.vcf + .\VirtualDub\pass2 .\VirtualDub\current.vcf >NUL
if %SkipVideo%==N b64.exe b64 %BitrateVideo%>>.\VirtualDub\current.vcf
if %SkipVideo%==N copy /B .\VirtualDub\current.vcf + .\VirtualDub\%XviD_Profile% .\VirtualDub\current.vcf >NUL
if %SkipVideo%==N echo VirtualDub.SaveAVI("..\\AVI\\%2.av4");>>.\VirtualDub\current.vcf
if %SkipAudio_WAV%==Y goto NO_AUDIO_WAV
if exist .\AVI\%2.wav del .\AVI\%2.wav
copy /B .\VirtualDub\current.vcf + .\VirtualDub\a .\VirtualDub\current.vcf >NUL
echo VirtualDub.audio.SetConversion(%AudioFrequency%,0,%AudioChannels%,0,1);>>.\VirtualDub\current.vcf
if NOT %StartMS%%EndMS%==01 echo VirtualDub.video.SetRange(%StartMS%,%EndMS%); >>.\VirtualDub\current.vcf
echo VirtualDub.SaveWAV("..\\AVI\\%2.wav"); >>.\VirtualDub\current.vcf
echo.>>.\VirtualDub\current.vcf
:NO_AUDIO_WAV
echo VirtualDub.Close();>>.\VirtualDub\current.vcf
echo.>>.\VirtualDub\current.vcf
echo // $endjob>>.\VirtualDub\current.vcf
echo //>>.\VirtualDub\current.vcf
echo //-------------------------------------------->>.\VirtualDub\current.vcf
echo // $done>>.\VirtualDub\current.vcf

cd VirtualDub
start /WAIT /%Priority% %Minimize% VirtualDub.exe /x /s current.vcf
if %Del_VCF%==Y del current.vcf >NUL
cd ..

if exist ".\AVI\%2_av4.tmp" del ".\AVI\%2_av4.tmp"

regedit /s user_ffdshow_vfw.reg
regedit /s user_ffdshow_audio.reg
regedit /s user_ffvdub.reg
if exist user_ffdshow_vfw.reg del user_ffdshow_vfw.reg
if exist user_ffdshow_audio.reg del user_ffdshow_audio.reg
if exist user_ffvdub.reg del user_ffvdub.reg
if exist ffvdub_settings.reg del ffvdub_settings.reg

echo ...Ok!

title Step %Process_counter%/%Process_all% - %2.%EXT%

;rem Normalize

if NOT exist AVI\%2.wav goto :AUDIO_PASS2
if %Normalize%==0 GOTO :AUDIO_PASS2

echo Step %Process_counter%/%Process_all% - Normaizing audio
set /a Process_counter=%Process_counter%+1

sox.exe AVI\%2.wav -e stat -v 2>sox_vol.txt
set /p sox_vol=<sox_vol.txt
del sox_vol.txt
sox.exe -v %sox_vol% AVI\%2.wav AVI\%2_avl.wav
if exist AVI\%2_avl.wav ( echo ...Ok!
	del AVI\%2.wav
	ren AVI\%2_avl.wav %2.wav
) else (
echo ...Error!
)

title Step %Process_counter%/%Process_all% - %2.%EXT%

:AUDIO_PASS2

if /i %BitrateAudio% LSS 13 (
	
	set DisAudio=-add ".\AVI\%2.amr"
	if %SkipAudio_M4A%==N echo Step %Process_counter%/%Process_all% - Encoding audio to AMR
	if %SkipAudio_M4A%==Y goto MUX

	if NOT exist .\AVI\%2.wav (
		echo ...Error!
		goto MUX
	)
	if exist .\AVI\%2.amr del .\AVI\%2.amr

	start /WAIT /%Priority% %Minimize% sox.exe .\AVI\%2.wav -r 8000 -w -c 1 .\AVI\%2_temp_.wav
	del .\AVI\%2.wav
	ren .\AVI\%2_temp_.wav %2.wav

	start /WAIT /%Priority% %Minimize% converter.exe wav2amr .\AVI\%2.wav .\AVI\%2.amr %AMRbitrate%

	if %Del_WAV%==Y del .\AVI\%2.wav

	set /a Process_counter=%Process_counter%+1
	
	if exist .\AVI\%2.amr ( echo ...Ok!
		) else ( echo ...Error!
	)

) else (

	set DisAudio=-add ".\AVI\%2.m4a"
	if %SkipAudio_M4A%==N echo Step %Process_counter%/%Process_all% - Encoding audio to AAC
	if %SkipAudio_M4A%==Y goto MUX

	if NOT exist .\AVI\%2.wav (
	echo ...Error!
	goto MUX
	)

	if exist .\AVI\%2.m4a del .\AVI\%2.m4a
	start /WAIT /%Priority% %Minimize% faac -w -c %AudioBandWidth% -b %BitrateAudio% .\AVI\%2.wav
	if %Del_WAV%==Y del .\AVI\%2.wav

	set /a Process_counter=%Process_counter%+1

	if exist .\AVI\%2.m4a ( echo ...Ok!
		) else ( echo ...Error!
	)
)


if %Del_AVI%==Y del .\AVI\%2.%EXT%

title Step %Process_counter%/%Process_all% - %2.%EXT%

:MUX
echo Step %Process_counter%/%Process_all% - Exporting to MP4 format
if %SkipMux%==Y (
echo ...ய饭
goto END 
)

set /a Process_counter=%Process_counter%+1

if exist .\AVI\temp_0x74656D70 del .\AVI\temp_0x74656D70 >NUL
if exist .\AVI\%2.mp4 del .\AVI\%2.mp4 >NUL
ren .\AVI\%2.av4 temp_0x74656D70.avi
echo.

if NOT exist .\AVI\%2.m4a if NOT exist .\AVI\%2.amr set DisAudio=

title Step %Process_counter%/%Process_all% - %2.%EXT%

if /i %EXT%==vob goto VOB_PROCESSING

:NORMAL

if %VideoSplit%==0 mp4box.exe -sync 100 -nodrop -add ".\AVI\temp_0x74656D70.avi#video" %DisAudio% ".\AVI\%2.mp4"

if NOT %VideoSplit%==0 ( echo Step %Process_counter%/%Process_all% - Video spliting
if %SplitToSubdir%==0 mp4box.exe -sync 100 -nodrop -add ".\AVI\temp_0x74656D70.avi#video" %DisAudio% ".\AVI\%2.mp4"
cd AVI
if %SplitToSubdir%==1 md %2_splited
cd ..
if %SplitToSubdir%==1 mp4box.exe -sync 100 -nodrop -add ".\AVI\temp_0x74656D70.avi#video" %DisAudio% ".\AVI\%2_splited\%2.mp4"
)

ren .\AVI\temp_0x74656D70.avi %2.av4

if %Del_M4A%==Y ( if exist .\AVI\%2.m4a del .\AVI\%2.m4a
if exist .\AVI\%2.amr del .\AVI\%2.amr
)

if %Del_AV4%==Y del .\AVI\%2.av4


set cur_time=%time%
set cur_time=%cur_time:~0,8%.%cur_time:~9,2%
set cur_date=%date%
set cur_date=%cur_date:~3,2%-%cur_date:~0,2%-%cur_date:~6,4%


if NOT %VideoSplit%==0 ( if %SplitToSubdir%==0 mp4box.exe -split %VideoSplit% ".\AVI\%2.mp4"
if %SplitToSubdir%==1 mp4box.exe -split %VideoSplit% ".\AVI\%2_splited\%2.mp4"

if %SplitToSubdir%==0 if EXIST .\AVI\%2_001.mp4 if %DeleteMP4%==1 del ".\AVI\%2.mp4"
if %SplitToSubdir%==1 if EXIST .\AVI\%2_splited\%2_001.mp4 if %DeleteMP4%==1 del ".\AVI\%2_splited\%2.mp4"

if %SplitToSubdir%==1 touch.exe /c /m /d %cur_date% /t %cur_time% AVI\%2_splited\%2*.mp4
if %SplitToSubdir%==0 touch.exe /c /m /d %cur_date% /t %cur_time% AVI\%2*.mp4

if %SplitToSubdir%==1 if NOT EXIST .\AVI\%2_splited\%2_001.mp4 ( move /Y .\AVI\%2_splited\%2.mp4 .\AVI\
RMDIR .\AVI\%2_splited
)
)

echo.
echo ...Ok!

:END
if %Del_STATS%==Y if exist .\VirtualDub\video.pass del .\VirtualDub\video.pass
echo.
echo ...Ok!
goto FIN

:VOB_PROCESSING


if %dvd%==0 goto NORMAL

if %dvd%==1 goto DVD1

mp4box.exe -sync 100 -nodrop -add ".\AVI\temp_0x74656D70.avi#video" %DisAudio% ".\AVI\%2.mp4"
ren .\AVI\temp_0x74656D70.avi %2.av4
if %Del_M4A%==Y ( if exist .\AVI\%2.m4a del .\AVI\%2.m4a
 if exist .\AVI\%2.amr del .\AVI\%2.amr
)
if %Del_AV4%==Y del .\AVI\%2.av4
cd AVI
if NOT %VideoSplit%==0 if %SplitToSubdir%==1 md %name:~0,-2%_splited
if NOT %VideoSplit%==0 if %SplitToSubdir%==1 move %2.mp4 %name:~0,-2%_splited
cd ..
goto END

:DVD1

title Step %Process_counter%/%Process_all% - %2.%EXT%

if %VideoSplit%==0 mp4box.exe -sync 100 -nodrop -add ".\AVI\temp_0x74656D70.avi#video" %DisAudio% ".\AVI\%2.mp4"

if NOT %VideoSplit%==0 ( echo Step %Process_counter%/%Process_all% - Video spliting
 if %SplitToSubdir%==0 mp4box.exe -sync 100 -nodrop -add ".\AVI\temp_0x74656D70.avi#video" %DisAudio% ".\AVI\%2.mp4"
 cd AVI
 if %SplitToSubdir%==1 md %name:~0,-2%_splited
 cd ..
 if %SplitToSubdir%==1 mp4box.exe -sync 100 -nodrop -add ".\AVI\temp_0x74656D70.avi#video" %DisAudio% ".\AVI\%name:~0,-2%_splited\%2.mp4"
)

ren .\AVI\temp_0x74656D70.avi %2.av4
if %Del_M4A%==Y ( if exist .\AVI\%2.m4a del .\AVI\%2.m4a
 if exist .\AVI\%2.amr del .\AVI\%2.amr
)
if %Del_AV4%==Y del .\AVI\%2.av4

set cat= 
set temp=0
:CAT_CALC
set /a temp=%temp%+1
if %temp%==10 goto CAT_CALC_END
if %VideoSplit%==0 if exist "AVI\%name:~0,-1%%temp%.mp4" set cat=%cat% -cat "AVI\%name:~0,-1%%temp%.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==1 if exist "AVI\%name:~0,-2%_splited\%name:~0,-1%%temp%.mp4" set cat=%cat% -cat "AVI\%name:~0,-2%_splited\%name:~0,-1%%temp%.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==0 if exist "AVI\%name:~0,-1%%temp%.mp4" set cat=%cat% -cat "AVI\%name:~0,-1%%temp%.mp4"
goto CAT_CALC
:CAT_CALC_END

if %VideoSplit%==0 mp4box.exe %cat% "AVI\%2_cat.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==1 mp4box.exe %cat% "AVI\%name:~0,-2%_splited\%2_cat.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==0 mp4box.exe %cat% "AVI\%2_cat.mp4"

if %VideoSplit%==0 ren "AVI\%name:~0,-1%0.mp4" "%name:~0,-1%0_.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==1 ren "AVI\%name:~0,-2%_splited\%name:~0,-1%0.mp4" "%name:~0,-1%0_.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==0 ren "AVI\%name:~0,-1%0.mp4" "%name:~0,-1%0_.mp4"

if %VideoSplit%==0 del "AVI\%name:~0,-1%?.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==1 del "AVI\%name:~0,-2%_splited\%name:~0,-1%?.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==0 del "AVI\%name:~0,-1%?.mp4"

if %VideoSplit%==0 ren "AVI\%2_cat.mp4" "%2.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==1 ren "AVI\%name:~0,-2%_splited\%2_cat.mp4" "%2.mp4"
if NOT %VideoSplit%==0 if %SplitToSubdir%==0 ren "AVI\%2_cat.mp4" "%2.mp4"

set cur_time=%time%
set cur_time=%cur_time:~0,8%.%cur_time:~9,2%
set cur_date=%date%
set cur_date=%cur_date:~3,2%-%cur_date:~0,2%-%cur_date:~6,4%

if NOT %VideoSplit%==0 ( if %SplitToSubdir%==0 mp4box.exe -split %VideoSplit% ".\AVI\%2.mp4"
 if %SplitToSubdir%==1 mp4box.exe -split %VideoSplit% ".\AVI\%name:~0,-2%_splited\%2.mp4"
 if %SplitToSubdir%==0 if EXIST .\AVI\%2_001.mp4 if %DeleteMP4%==1 del ".\AVI\%2.mp4"
 if %SplitToSubdir%==1 if EXIST .\AVI\%name:~0,-2%_splited\%2_001.mp4 if %DeleteMP4%==1 del ".\AVI\%name:~0,-2%_splited\%2.mp4"
 if %SplitToSubdir%==1 touch.exe /c /m /d %cur_date% /t %cur_time% AVI\%name:~0,-2%_splited\%2*.mp4
 if %SplitToSubdir%==0 touch.exe /c /m /d %cur_date% /t %cur_time% AVI\%2*.mp4
 if %SplitToSubdir%==1 if NOT EXIST .\AVI\%name:~0,-2%_splited\%2_001.mp4 ( move /Y .\AVI\%name:~0,-2%_splited\%2.mp4 .\AVI\
  RMDIR .\AVI\%name:~0,-2%_splited
 )
)

if exist .\AVI\%name:~0,-2%_splited\%2.mp4 move /Y .\AVI\%name:~0,-2%_splited\%2.mp4 .\AVI\

goto END

:RENM
echo **** AVI
ren %2 *.
if errorlevel 1 (
	Title error
	pause
	goto FIN
	)
cd AVI
for %%x in (*.) do call %0 A %%x
goto FIN

:RENM_MPG
echo **** MPG
ren %2 *.
if errorlevel 1 (
	Title error
	pause
	goto FIN
	)
cd AVI
for %%x in (*.) do call %0 A %%x MPG
goto FIN

:RENM_MPEG
echo **** MPEG !
ren %2 *.
if errorlevel 1 (
	Title error
	pause
	goto FIN
	)
cd AVI
for %%x in (*.) do call %0 A %%x MPEG
goto FIN

:RENM_VOB
echo **** VOB !
ren %2 *.
if errorlevel 1 (
	Title error
	pause
	goto FIN
	)
cd AVI
for %%x in (*.) do call %0 A %%x VOB
goto FIN

:RENM_ASF
echo **** ASF !
ren %2 *.
if errorlevel 1 (
	Title error
	pause
	goto FIN
	)
cd AVI
for %%x in (*.) do call %0 A %%x ASF
goto FIN

:RENM_WMV
echo **** WMV !
ren %2 *.
if errorlevel 1 (
	Title error
	pause
	goto FIN
	)
cd AVI
for %%x in (*.) do call %0 A %%x WMV
goto FIN

:FIN
